import threading

from bot_api.api import Api
from bot_api.logging.api_logger import ApiLogger


class ApiThread(threading.Thread):
    def __init__(self, logger: ApiLogger, api: Api):
        threading.Thread.__init__(self, daemon=True)

        self._logger = logger
        self._api = api

    def run(self) -> None:
        try:
            self._logger.trace(__name__, f"Try to start {type(self._api).__name__}")
            self._api.start()
        except Exception as e:
            self._logger.error(__name__, "Start failed", e)
