ALTER TABLE `AuthUserUsersRelations`
    MODIFY `LastModifiedAt` DATETIME(6) NULL ON UPDATE CURRENT_TIMESTAMP(6);

ALTER TABLE `AuthUserUsersRelations`
    ALTER COLUMN `CreatedAt` SET DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `AuthUserUsersRelations`
    ALTER COLUMN `LastModifiedAt` SET DEFAULT CURRENT_TIMESTAMP(6);


CREATE TABLE IF NOT EXISTS `AuthUserUsersRelationsHistory`
(
    `Id`         BIGINT(20)  NOT NULL,
    `AuthUserId` BIGINT(20) DEFAULT NULL,
    `UserId`     BIGINT(20) DEFAULT NULL,
    `Deleted`    BOOL       DEFAULT FALSE,
    `DateFrom`   DATETIME(6) NOT NULL,
    `DateTo`     DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_AuthUserUsersRelationsUpdate`;

CREATE TRIGGER `TR_AuthUserUsersRelationsUpdate`
    AFTER UPDATE
    ON `AuthUserUsersRelations`
    FOR EACH ROW
BEGIN
    INSERT INTO `AuthUserUsersRelationsHistory` (
        `Id`, `AuthUserId`, `UserId`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.AuthUserId, OLD.UserId, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_AuthUserUsersRelationsDelete`;

CREATE TRIGGER `TR_AuthUserUsersRelationsDelete`
    AFTER DELETE
    ON `AuthUserUsersRelations`
    FOR EACH ROW
BEGIN
    INSERT INTO `AuthUserUsersRelationsHistory` (
        `Id`, `AuthUserId`, `UserId`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.AuthUserId, OLD.UserId, TRUE, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;